class SharepointApi
  class FilenameCleaner
    # Windows doesn't allow these characters in file names.
    INVALID_CHARS_REGEX = %r([~"#%&*:<>?/\\{\|}]).freeze

    def self.call(filename, invalid_character_regex: nil)
      new(invalid_character_regex).call(filename)
    end

    def initialize(invalid_character_regex = nil)
      @invalid_character_regex = invalid_character_regex || INVALID_CHARS_REGEX
    end

    def call(filename)
      if @invalid_character_regex
        filename.gsub(@invalid_character_regex, '')
      else
        filename
      end
    end
  end
end
