require_relative 'sharepoint_error'

class SharepointApi
  module Users
    def ensure_user(login_name)
      body = {
        'logonName' => login_name
      }
      site.query(:post, 'ensureUser', body.to_json)
    rescue Sharepoint::SPException => e
      log_as(__method__, e)
      nil
    end

    def fetch_user_id_from_login_name(login_name)
      encoded_login_name = ERB::Util.url_encode(login_name)

      url = "/SiteUsers/GetByLoginName(@v)?@v='#{encoded_login_name}'&$select=Id"
      site.query(:get, url)&.id
    rescue Sharepoint::SPException => e
      log_as(__method__, e)
      nil
    end
  end
end
